/*
 * FilterWindow.java
 */
package paldirvd;

import java.awt.Event;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.JOptionPane;

public class ActualFieldWindow1 extends javax.swing.JFrame {

    private VDWindow vdView;

    /** Creates new form FilterWindow */
    public ActualFieldWindow1(VDWindow vd_view) {
        initComponents();
        vdView = vd_view;
 

    }

    class FrameListener extends WindowAdapter {

        public void windowClosing(WindowEvent e) {
            vdView.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
            vdView.setEnabled(true);
        }
    }

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        decInput = new javax.swing.JTextField();
        incInput = new javax.swing.JTextField();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();

        setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        setLocationByPlatform(true);
        setResizable(false);

        jLabel1.setText("PRESENT FIELD");

        jLabel2.setText("Dec");

        jLabel3.setText("Inc");

        decInput.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                decInputKeyTyped(evt);
            }
        });

        incInput.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                incInputKeyTyped(evt);
            }
        });

        okButton.setText("ok");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        cancelButton.setText("cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(jLabel2)
                            .add(jLabel3))
                        .add(18, 18, 18)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel1)
                            .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                                .add(decInput)
                                .add(incInput, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 111, Short.MAX_VALUE))))
                    .add(layout.createSequentialGroup()
                        .add(okButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 41, Short.MAX_VALUE)
                        .add(cancelButton)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(23, 23, 23)
                .add(jLabel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 16, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(18, 18, 18)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(decInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(18, 18, 18)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel3)
                    .add(incInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(18, 18, 18)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(okButton)
                    .add(cancelButton))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        enter();
    }//GEN-LAST:event_okButtonActionPerformed

    private void decInputKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_decInputKeyTyped
        if (Event.ENTER == evt.getKeyChar()) {
            enter();
        }
}//GEN-LAST:event_decInputKeyTyped
    private void incInputKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_incInputKeyTyped
        if (Event.ENTER == evt.getKeyChar()) {
            enter();
        }
}//GEN-LAST:event_incInputKeyTyped

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        cancel();
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void enter() {

        String dec = decInput.getText();
        String inc = incInput.getText();

        if (dec.equals("")) {
            dec = "0";
        }
        if (inc.equals("")) {
            inc = "0";
        }

        try {
            double declination = Double.parseDouble(dec);
            double inclination = Double.parseDouble(inc);
            Position actualField = new Position(declination, inclination, 0);

            vdView.setActualField(actualField);
            vdView.setEnabled(true);
            vdView.setDefaultCloseOperation(DISPOSE_ON_CLOSE);

            this.setVisible(false);
        } catch (Exception ex) {
            System.out.println(ex);
            JOptionPane.showMessageDialog(this.rootPane, "Data is not valid");
        }
    }

    private void cancel() {
        vdView.setActualField(null);
        vdView.setEnabled(true);
        vdView.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        this.setVisible(false);
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JTextField decInput;
    private javax.swing.JTextField incInput;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JButton okButton;
    // End of variables declaration//GEN-END:variables
}
