/*
 * DecIncWindow.java
 *
 * Created on 21 de diciembre de 2011, 12:16
 */

package paldirvd;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.util.Vector;
import javax.swing.ImageIcon;

/**
 *
 * @author  IGMEZ12
 */
public class DecIncWindow extends javax.swing.JFrame {
        
    private int[] colorScale;
    private double scal, minim=0;
    private Vector names = new Vector();
    private static String SPEC="Specimen", STEPMIN="Step min", STEPMAX="Step max", INT="Intensity", MAD="MAD", N="Nº steps";
    private boolean dvd=true;
    private Vector vds, allVds; 
    private boolean xlabel=true;
    
    /** Creates new form DecIncWindow */
    public DecIncWindow(Vector virtuals) {
        allVds=virtuals; 
        vds=VirtualDirections.getRV(allVds);
        colorScale=new int[vds.size()];
        String name, name0="";
        int dato=0; names.clear();
        for (int i=0; i<vds.size(); i++){
            name=((VD)vds.get(i)).getNameCore();
            if(!name.equals(name0)) {dato=dato+1; name0=name; names.add(name);}
            colorScale[i]=dato;
        }scal=dato;
        
        initComponents();  
    }
    
    
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        panel = new javax.swing.JPanel();
        xlabButton = new javax.swing.JToggleButton();
        legendPanel = new javax.swing.JPanel();
        legendField = new javax.swing.JTextField();
        logoPanel = new javax.swing.JPanel();
        difResButton = new javax.swing.JToggleButton();
        specButt = new javax.swing.JButton();
        nButt = new javax.swing.JButton();
        stepMinButt = new javax.swing.JButton();
        stepMaxButt = new javax.swing.JButton();
        intButt = new javax.swing.JButton();
        MADButt = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Virtual Directions - Declination/Inclination");

        panel.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        panel.setMinimumSize(new java.awt.Dimension(400, 200));
        panel.setPreferredSize(new java.awt.Dimension(600, 300));

        xlabButton.setFont(new java.awt.Font("Lucida Grande", 0, 10));
        xlabButton.setText("Dec [0º:360º]");
        xlabButton.setBorder(javax.swing.BorderFactory.createTitledBorder(""));
        xlabButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                xlabButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout panelLayout = new javax.swing.GroupLayout(panel);
        panel.setLayout(panelLayout);
        panelLayout.setHorizontalGroup(
            panelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, panelLayout.createSequentialGroup()
                .addContainerGap(494, Short.MAX_VALUE)
                .addComponent(xlabButton, javax.swing.GroupLayout.PREFERRED_SIZE, 96, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        panelLayout.setVerticalGroup(
            panelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, panelLayout.createSequentialGroup()
                .addContainerGap(264, Short.MAX_VALUE)
                .addComponent(xlabButton)
                .addContainerGap())
        );

        legendField.setEditable(false);
        legendField.setText("Specimen");

        javax.swing.GroupLayout legendPanelLayout = new javax.swing.GroupLayout(legendPanel);
        legendPanel.setLayout(legendPanelLayout);
        legendPanelLayout.setHorizontalGroup(
            legendPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(legendPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(legendField, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        legendPanelLayout.setVerticalGroup(
            legendPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(legendPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(legendField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(226, Short.MAX_VALUE))
        );

        logoPanel.setPreferredSize(new java.awt.Dimension(170, 48));

        javax.swing.GroupLayout logoPanelLayout = new javax.swing.GroupLayout(logoPanel);
        logoPanel.setLayout(logoPanelLayout);
        logoPanelLayout.setHorizontalGroup(
            logoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 174, Short.MAX_VALUE)
        );
        logoPanelLayout.setVerticalGroup(
            logoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 48, Short.MAX_VALUE)
        );

        difResButton.setText("DVD");
        difResButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                difResButtonActionPerformed(evt);
            }
        });

        specButt.setText("Specimen");
        specButt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                specButtActionPerformed(evt);
            }
        });

        nButt.setText("Nº steps");
        nButt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nButtActionPerformed(evt);
            }
        });

        stepMinButt.setText("Step min");
        stepMinButt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                stepMinButtActionPerformed(evt);
            }
        });

        stepMaxButt.setText("Step max");
        stepMaxButt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                stepMaxButtActionPerformed(evt);
            }
        });

        intButt.setText("Intensity");
        intButt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                intButtActionPerformed(evt);
            }
        });

        MADButt.setText("MAD");
        MADButt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MADButtActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(specButt, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(nButt, javax.swing.GroupLayout.PREFERRED_SIZE, 86, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(stepMinButt, javax.swing.GroupLayout.PREFERRED_SIZE, 87, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(stepMaxButt, javax.swing.GroupLayout.PREFERRED_SIZE, 93, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(intButt, javax.swing.GroupLayout.PREFERRED_SIZE, 87, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(MADButt)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(logoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 174, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(panel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(legendPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(difResButton))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(panel, javax.swing.GroupLayout.DEFAULT_SIZE, 299, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(4, 4, 4)
                        .addComponent(difResButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(legendPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(8, 8, 8)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(specButt)
                            .addComponent(nButt)
                            .addComponent(stepMinButt)
                            .addComponent(stepMaxButt)
                            .addComponent(intButt)
                            .addComponent(MADButt)))
                    .addGroup(layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(logoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
            
    private void difResButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_difResButtonActionPerformed
        if(dvd){
            dvd=false;
            difResButton.setText("RVD");
            vds=VirtualDirections.getDV(allVds);
        }else{
            dvd=true;
            difResButton.setText("DVD");
            vds=VirtualDirections.getRV(allVds);            
        }
        actualizeColor();
}//GEN-LAST:event_difResButtonActionPerformed

    private void specButtActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_specButtActionPerformed
        legendField.setText(SPEC);      
        actualizeColor();
        
}//GEN-LAST:event_specButtActionPerformed

    private void nButtActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nButtActionPerformed
        legendField.setText(N); 
        actualizeColor();     
    }//GEN-LAST:event_nButtActionPerformed

    private void stepMinButtActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_stepMinButtActionPerformed
        legendField.setText(STEPMIN); 
        actualizeColor();
    }//GEN-LAST:event_stepMinButtActionPerformed

    private void stepMaxButtActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_stepMaxButtActionPerformed
        legendField.setText(STEPMAX); 
        actualizeColor();
    }//GEN-LAST:event_stepMaxButtActionPerformed

    private void intButtActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_intButtActionPerformed
        legendField.setText(INT); 
        actualizeColor();
    }//GEN-LAST:event_intButtActionPerformed

    private void MADButtActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MADButtActionPerformed
        legendField.setText(MAD); 
        actualizeColor();
    }//GEN-LAST:event_MADButtActionPerformed
    
    private void actualizeColor(){
            String name, name0="";
        int dato=0, min=9999999, max=0;
        if (legendField.getText().equals(SPEC)) names.clear();
        for (int i=0; i<vds.size(); i++){
            if (legendField.getText().equals(SPEC)){
                name=((VD)vds.get(i)).getNameCore();
                if(!name.equals(name0)) {dato=dato+1; name0=name; names.add(name);}
            }
            if (legendField.getText().equals(N))
                dato=((VD)vds.get(i)).getNumSteps();
            if (legendField.getText().equals(STEPMIN))
                dato=(int) ((VD)vds.get(i)).getStepIni();
            if (legendField.getText().equals(STEPMAX))
                dato=(int) ((VD)vds.get(i)).getStepEnd();
            if (legendField.getText().equals(INT))
                dato=(int) ((VD)vds.get(i)).getPos().getInt();
            if (legendField.getText().equals(MAD))
                dato=(int) ((VD)vds.get(i)).getPos().getError();
            colorScale[i]=dato;
            if(dato>max) max=dato;
            if(dato<min) min=dato;
        }
        if (legendField.getText().equals(SPEC)){
            scal=dato; 
        }else{
            //col=colorScale; Arrays.sort(col); scal=col[vds.size()-1]-col[0];
            scal=max-min; minim=min;
        }
        plot();
    }
        
    private void xlabButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_xlabButtonActionPerformed
        if(xlabel){
            xlabel=false; xlabButton.setText("Dec [-180º:180º]");
        }else{
            xlabel=true; xlabButton.setText("Dec [0º:360º]");
        }plot();
    }//GEN-LAST:event_xlabButtonActionPerformed
  
    public void paint(Graphics g){
        super.paint(getGraphics());
        paintComponent(g);
        plot();
    }
    
    public void paintComponent(Graphics g) {
        g=logoPanel.getGraphics();
        ImageIcon imag = new ImageIcon("logoVPD.jpg");     
        g.drawImage(imag.getImage(), 0, 0,  imag.getIconWidth() ,  imag.getIconHeight(), null);
        logoPanel.paintComponents(g);
    }
    
    private void plot(){

      //INITIALIZE GRAPHIC
      Graphics g = panel.getGraphics();
      panel.paint(g);
      Dimension tam = panel.getSize();
 
      int Dx = tam.width; int Dy = tam.height;  int d0 = 40; Dx=Dx-d0; Dy=Dy-d0; Dy=Dy/2;

      int x0 = d0/2; int y0 = Dy+d0/2; // sw corner

      g.setColor (Color.GRAY);
      g.drawLine(x0, y0 , x0+Dx, y0); // axes
      g.drawLine(x0, y0-Dy , x0, y0+Dy);

      g.setColor(Color.DARK_GRAY);
      g.drawString("Dec (º)", x0+Dx-30, y0-10); //xlabel
      g.drawString("Inc (º)", x0+10, y0-Dy+10); //ylabel

      g.setFont(new Font("Tahoma", 0, 10)); //y labels
      for (double i=-90; i<=90; i=i+20){
        g.drawLine(x0-3,y0+(int)i*Dy/90,x0+3,y0+(int)i*Dy/90);      
      }g.drawString("-90",x0-15,y0+Dy+3); g.drawString("-50",x0-15,y0+(int)(Dy*0.55)+3); g.drawString("50",x0-12,y0-(int)(Dy*0.55)+3); g.drawString("90",x0-12,y0-Dy+3);
      
      for (double i=20; i<=360; i=i+20){ //x labels
            g.drawLine(x0+(int)i*Dx/360,y0-3,x0+(int)i*Dx/360,y0+3); 
      }
      if(xlabel){  
          g.drawString("180",x0+(int)(Dx*0.5)-8,y0+13);g.drawString("360",x0+Dx-8,y0+13);
      }else{
          g.drawString("-180",x0-8,y0+13);g.drawString("0",x0+(int)(Dx*0.5)-8,y0+13);g.drawString("180",x0+Dx-8,y0+13);
      }
      
      //plot dec/inc
      Colormap colors = new Colormap();
      int posCol=0;
      VD vd; double x,y;
      for (int i=0; i<vds.size(); i++){
            vd=(VD)vds.get(i);
                  
                  if (colorScale.length>1){   //escala de colores
                    posCol=(int)(colorScale[i]*64/scal);
                    if(posCol<0) posCol=0; if(posCol>63) posCol=63;
                    g.setColor(colors.getCol(posCol));
                  }
                  //System.out.println("i: "+i+", ind: "+colorScale[i]+"posCol: "+posCol); 
                  x=vd.getPos().getDec();  
                  if(!xlabel) {x=x-180; if(x<0) x=x+360;}
                  x=x0+x*Dx/360;
                  y=vd.getPos().getInc(); y=y0+y*Dy/180; 
                  g.fillOval((int)x,(int)y,4,4);
 
      }
      plotLegend();
    }
          
    private void plotLegend(){
      Graphics g = legendPanel.getGraphics();
      Colormap colors = new Colormap();
      legendPanel.paint(g);
      int dy=legendPanel.getHeight()-50;
      int inc = (int)Math.ceil(dy/64); 
      int posy = 0;
      int x0=12, y0=40;
      int xpoints[]={x0, x0+20, x0+20, x0}, ypoints[]={y0, y0, y0+dy, y0+dy};
      int ind=0;
      g.setFont(new Font("Tahoma", 0, 10)); 
      for (int i=0; i<64; i++){
          g.setColor(colors.getCol(63-i));
          ypoints[0]=y0+posy; ypoints[1]=y0+posy;
          posy=posy+inc;
          ypoints[2]=y0+posy; ypoints[3]=y0+posy;
          g.fillPolygon(xpoints, ypoints, 4);
          if(i==0 || i==8 || i==16|| i==24 || i==32|| i==40|| i==48|| i==56){
              g.drawLine(x0+20, y0+posy, x0+25, y0+posy);
              //ind=colorScale[(int)((63-i)*colorScale.length/64)];
              ind=(int)((63-i)*scal/64+minim);
              if(legendField.getText().equals(SPEC)){
                  if (ind>names.size()) ind=names.size(); if(ind<1) ind=1;
                g.drawString((String)names.get(ind-1),x0+30, y0+posy+5);
              }else
                g.drawString(ind+"",x0+30, y0+posy+5);
              //System.out.println("Ind: "+ind); 

          }
      }
      

    }
   
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton MADButt;
    private javax.swing.JToggleButton difResButton;
    private javax.swing.JButton intButt;
    private javax.swing.JTextField legendField;
    private javax.swing.JPanel legendPanel;
    private javax.swing.JPanel logoPanel;
    private javax.swing.JButton nButt;
    private javax.swing.JPanel panel;
    private javax.swing.JButton specButt;
    private javax.swing.JButton stepMaxButt;
    private javax.swing.JButton stepMinButt;
    private javax.swing.JToggleButton xlabButton;
    // End of variables declaration//GEN-END:variables
    
}
