/*
 * LSAWindow.java
 *
 * Created on 20 de diciembre de 2011, 12:13
 */

package paldirvd;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Vector;
import javax.swing.ImageIcon;

/**
 *
 * @author  IGMEZ12
 */
public class LSAWindow extends javax.swing.JFrame {
    
    private boolean Res = true;
    private Vector vdAll, finalSite;
    private Vector linearityVector, vdsVector, directionsVector, allStepsVector, names;
    private HashMap linMean; 
    private int meanStep;
    
    /** Creates new form LSAWindow */
    public LSAWindow(Vector vdirs, Vector final_site) {
        initComponents();
        vdAll = vdirs;
        finalSite = final_site;
        calculateStepsVector();
        specimenLinearity();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        linearityPanel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        meanLinPanel = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        dirPanel = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        textArea = new javax.swing.JTextArea();
        legendPanel = new javax.swing.JPanel();
        RDButton = new javax.swing.JToggleButton();
        logoPan = new javax.swing.JPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Linearity Spectrum Analysis, Schmidt [1982]");

        linearityPanel.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        linearityPanel.setMinimumSize(new java.awt.Dimension(200, 100));
        linearityPanel.setPreferredSize(new java.awt.Dimension(400, 200));

        jLabel1.setText("Specimen linearity");

        javax.swing.GroupLayout linearityPanelLayout = new javax.swing.GroupLayout(linearityPanel);
        linearityPanel.setLayout(linearityPanelLayout);
        linearityPanelLayout.setHorizontalGroup(
            linearityPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(linearityPanelLayout.createSequentialGroup()
                .addGap(217, 217, 217)
                .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(226, 226, 226))
        );
        linearityPanelLayout.setVerticalGroup(
            linearityPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(linearityPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addContainerGap(250, Short.MAX_VALUE))
        );

        meanLinPanel.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        meanLinPanel.setMinimumSize(new java.awt.Dimension(200, 100));
        meanLinPanel.setPreferredSize(new java.awt.Dimension(400, 200));

        jLabel2.setText("Mean linearity");

        javax.swing.GroupLayout meanLinPanelLayout = new javax.swing.GroupLayout(meanLinPanel);
        meanLinPanel.setLayout(meanLinPanelLayout);
        meanLinPanelLayout.setHorizontalGroup(
            meanLinPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(meanLinPanelLayout.createSequentialGroup()
                .addGap(233, 233, 233)
                .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(237, 237, 237))
        );
        meanLinPanelLayout.setVerticalGroup(
            meanLinPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(meanLinPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel2)
                .addContainerGap(232, Short.MAX_VALUE))
        );

        textArea.setBackground(new java.awt.Color(238, 238, 238));
        textArea.setColumns(20);
        textArea.setEditable(false);
        textArea.setRows(3);
        textArea.setAutoscrolls(false);
        textArea.setBorder(null);
        textArea.setDragEnabled(false);
        jScrollPane1.setViewportView(textArea);

        legendPanel.setOpaque(false);

        javax.swing.GroupLayout legendPanelLayout = new javax.swing.GroupLayout(legendPanel);
        legendPanel.setLayout(legendPanelLayout);
        legendPanelLayout.setHorizontalGroup(
            legendPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 107, Short.MAX_VALUE)
        );
        legendPanelLayout.setVerticalGroup(
            legendPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 275, Short.MAX_VALUE)
        );

        RDButton.setText("RVD");
        RDButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RDButtonActionPerformed(evt);
            }
        });

        logoPan.setPreferredSize(new java.awt.Dimension(170, 48));

        javax.swing.GroupLayout logoPanLayout = new javax.swing.GroupLayout(logoPan);
        logoPan.setLayout(logoPanLayout);
        logoPanLayout.setHorizontalGroup(
            logoPanLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 170, Short.MAX_VALUE)
        );
        logoPanLayout.setVerticalGroup(
            logoPanLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 48, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout dirPanelLayout = new javax.swing.GroupLayout(dirPanel);
        dirPanel.setLayout(dirPanelLayout);
        dirPanelLayout.setHorizontalGroup(
            dirPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(dirPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(dirPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, dirPanelLayout.createSequentialGroup()
                        .addComponent(RDButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 165, Short.MAX_VALUE)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 188, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(dirPanelLayout.createSequentialGroup()
                        .addComponent(legendPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 151, Short.MAX_VALUE)
                        .addComponent(logoPan, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        dirPanelLayout.setVerticalGroup(
            dirPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, dirPanelLayout.createSequentialGroup()
                .addGroup(dirPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(legendPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(dirPanelLayout.createSequentialGroup()
                        .addGap(6, 6, 6)
                        .addComponent(logoPan, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 205, Short.MAX_VALUE)
                .addGroup(dirPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 54, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(RDButton))
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(linearityPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 561, Short.MAX_VALUE)
                    .addComponent(meanLinPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 561, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(dirPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(dirPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(linearityPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 276, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(meanLinPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 258, Short.MAX_VALUE)))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void RDButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RDButtonActionPerformed
        if(Res) {
            Res = false;
            RDButton.setText("DVD");
        }else{
            Res = true; 
            RDButton.setText("RVD");
        }
        specimenLinearity();
    }//GEN-LAST:event_RDButtonActionPerformed
    
private void calculateStepsVector(){
    Vector stepsCore;
    int step;
    allStepsVector = new Vector();  
    
    for(int i=0; i<finalSite.size(); i++){
        stepsCore = ((Core)finalSite.get(i)).getSteps();
        for(int j=0; j<stepsCore.size(); j++){
            step = (int) ((Step)stepsCore.get(j)).getTemp();
            if (!allStepsVector.contains(step))
                allStepsVector.add(step);
        }
    }
    Object a[] = allStepsVector.toArray();
    Arrays.sort(a); 
    for (int i=1; i<a.length; i++) allStepsVector.set(i,a[i]);
}   

private void specimenLinearity(){
    Vector vds;     
    if (Res)
        vds=VirtualDirections.getRV(vdAll); //Resultant virtual directions
    else
        vds=VirtualDirections.getDV(vdAll); //Difference virtual directions
            
    HashMap linearity = new HashMap(), vdLSA = new HashMap(), steps = new HashMap(); 
    VD vd; 
    linearityVector = new Vector(); vdsVector = new Vector(); linMean = new HashMap();
    String name, nameCore; int stepMean; double lin, linear; 
        
        int numCore = 0;
        Vector stepsVector = new Vector();
        Vector stepsCore = ((Core)finalSite.get(numCore)).getSteps();
        for(int j=0; j<stepsCore.size(); j++){
            stepsVector.add((int)((Step)stepsCore.get(j)).getTemp());
                    
        }
    name=((VD) vds.get(0)).getNameCore();
    for(int i=0; i<vds.size(); i++){
        vd = (VD) vds.get(i);
        
      if (vd.getNumSteps()>2){
      
        nameCore = vd.getNameCore();
        int indice = (int)Math.floor((stepsVector.indexOf((int)vd.getStepIni())+stepsVector.indexOf((int)vd.getStepEnd()))/2);
               
        stepMean = (Integer) stepsVector.get(indice);
        lin = 1-Math.sin(Math.toRadians(vd.getPos().getError()));
        
        if (name.equals(nameCore)){            
            
            if (linearity.containsKey(stepMean)){             
                linear = (Double)linearity.get(stepMean);
                if (linear < lin){
                    linearity.put(stepMean, lin);
                    vdLSA.put(stepMean, vd);
                }
            }else{
                linearity.put(stepMean,lin);
                vdLSA.put(stepMean, vd);
            }
            
        }else{
            numCore = numCore+1;
            stepsVector = new Vector();
            stepsCore = ((Core)finalSite.get(numCore)).getSteps();
            for(int j=0; j<stepsCore.size(); j++){
                 stepsVector.add((int)((Step)stepsCore.get(j)).getTemp());
           }
            linearityVector.add(linearity);
            vdsVector.add(vdLSA); 
            name = nameCore; linearity = new HashMap(); vdLSA = new HashMap();
        }
      } 
    }
    linearityVector.add(linearity); vdsVector.add(vdLSA); //last core

    Vector numSpec = new Vector(); for (int i=0; i<allStepsVector.size(); i++) numSpec.add(0);
    for(int i=0; i<linearityVector.size(); i++){
        linearity = (HashMap) linearityVector.get(i);
 
        for(int j=0; j<allStepsVector.size(); j++){
            stepMean=(Integer)allStepsVector.get(j);
            
            if (linearity.containsKey(stepMean)){
                lin=(Double)linearity.get(stepMean);
                
                if (linMean.containsKey(stepMean))
                    lin = lin + (Double)linMean.get(stepMean);

                linMean.put(stepMean, lin);
                numSpec.set(j,(Integer)numSpec.get(j)+1);
            }
        }
    } 
    double linMax=0;
    for(int j=0; j<allStepsVector.size(); j++){
        stepMean=(Integer)allStepsVector.get(j);
        if (linMean.containsKey(stepMean)){
            lin=(Double)linMean.get(stepMean)/(Integer)numSpec.get(j);
            linMean.put(stepMean, lin);
            if(linMax<lin){ 
                linMax=lin;
                meanStep=stepMean;
            }
        }
    }
    directions();    
    paint(super.getGraphics());

}

private void directions(){
    
    directionsVector = new Vector(); names = new Vector();
    VD vd; int step=meanStep; int index;
    for(int i=0; i<vdsVector.size(); i++){
        while (!((HashMap)vdsVector.get(i)).containsKey(step)){
            index = (allStepsVector.indexOf(step)+1)%allStepsVector.size();
            step = (Integer)allStepsVector.get(index);
        }
        vd = (VD)((HashMap)vdsVector.get(i)).get(step);
        directionsVector.add(vd.getPos());
        names.add(vd.getNameCore());
        step = meanStep;
        
    }

}


    public void paint(Graphics g){
        super.paint(getGraphics());
        plotMeanLinearity();
        plotSpecimenLinearity();
        stereonet();
        legend();
       // paintComponent(g);
    }
    
private void plotMeanLinearity(){
    Graphics2D g = (Graphics2D) meanLinPanel.getGraphics();
    meanLinPanel.paint(g);
    
    int Y = meanLinPanel.getHeight() - 50;
    int X = meanLinPanel.getWidth() - 30;
    
    int y0 = Y + 30, x0 = 15;
    
    g.setColor (Color.GRAY);
      g.drawLine(x0, y0, x0+X, y0); // axes
      g.drawLine(x0, y0, x0, y0-Y); 
      
    g.setFont(new Font((g.getFont()).getFontName(), Font.PLAIN, 9));  
    g.setColor (Color.RED);  

    int step;
    int stepMin=(int)((Integer)allStepsVector.get(1)*0.95);
    int stepMax=(int)((Integer)allStepsVector.get(allStepsVector.size()-2)*1.05);
    int x1, y1, x2=x0, y2=y0, d=5, yMin=y0;
    double lin, linMin=1;

    for(int i=0; i<allStepsVector.size(); i++){
        step=(Integer)allStepsVector.get(i); 
        if (linMean.containsKey(step)){
            lin=(Double)linMean.get(step);
            x1 = x0+(int)((step-stepMin)*X/(stepMax-stepMin)); y1 = y0-(int)(lin*Y);        

            g.fillOval(x1-d/2, y1-d/2, d, d);
            if (i>1&&i<allStepsVector.size()-1){
                g.drawLine(x1, y1, x2, y2);
            }                
            x2=x1; y2=y1;
            g.setColor (Color.GRAY);
            g.drawString(""+(int)step, x1, y0+10);
            g.setColor (Color.RED);
            if(lin<linMin) {linMin=lin; yMin=y1;}
        }
    }
        g.setColor (Color.GRAY);
        g.drawString("1", x0+2, y0-Y);
        g.drawString(""+Math.round(linMin*100)/100d, x0+2, yMin);
        g.drawString("Demagnetization step",x0+X-120,y0-5);

}

private void plotSpecimenLinearity(){
    Graphics2D g = (Graphics2D) linearityPanel.getGraphics();
    linearityPanel.paint(g);
    
    int Y = linearityPanel.getHeight() - 50;
    int X = linearityPanel.getWidth() - 30;
    
    int y0 = Y + 30, x0 = 15;
    
    g.setColor (Color.GRAY);
    g.drawLine(x0, y0, x0+X, y0); // axes
    g.drawLine(x0, y0, x0, y0-Y); 

    int step;
    int stepMin=(int)((Integer)allStepsVector.get(1)*0.95);
    int stepMax=(int)((Integer)allStepsVector.get(allStepsVector.size()-2)*1.05);
    int x1, y1, x2=x0, y2=y0, d=5, yMin=y0;
    double lin, linMin=1;
    Colormap colors = new Colormap();
    int posCol;

    
for (int j=0; j<linearityVector.size(); j++){
    HashMap specLin = (HashMap)linearityVector.get(j);
    posCol=(int)(j*64/linearityVector.size());
    g.setColor(colors.getCol(posCol));
    
    for(int i=0; i<allStepsVector.size(); i++){
        step=(Integer)allStepsVector.get(i); 
        if (specLin.containsKey(step)){
            lin=(Double)specLin.get(step);
            x1 = x0+(int)((step-stepMin)*X/(stepMax-stepMin)); y1 = y0-(int)(lin*Y);        
            g.fillOval(x1-d/2, y1-d/2, d, d);
            if (i>1&&i<allStepsVector.size()-1){
                g.drawLine(x1, y1, x2, y2);
            }                
            x2=x1; y2=y1;
            if(lin<linMin) {linMin=lin; yMin=y1;}
        }
    }
 }
    
        //xlabels
        g.setColor (Color.GRAY);              
        g.setFont(new Font((g.getFont()).getFontName(), Font.PLAIN, 9));  
        for(int i=0; i<allStepsVector.size()-1; i++){
            step=(Integer)allStepsVector.get(i);
            x1 = x0+(int)((step-stepMin)*X/(stepMax-stepMin));     
            g.drawString(""+(int)step, x1, y0+10);
        }
        g.drawString("1", x0+2, y0-Y);
        g.drawString(""+Math.round(linMin*100)/100d, x0+2, yMin);
        g.drawString("Demagnetization step",x0+X-120,y0-5);

}
    

    private void stereonet() {

      Graphics2D g = (Graphics2D) dirPanel.getGraphics();
      dirPanel.paint(g);
                
      Dimension tam = dirPanel.getSize(); // plotPanel size
      int d = Math.min( tam.width,tam.height ) - 2; // diameter
      int x0 = (tam.width - d) / 2 + 1;
      int y0 = (tam.height - d) / 2 + 1;
     
      g.setColor (Color.GRAY);
      g.drawOval(x0, y0, d, d);// border circunference
      g.drawLine(x0+d/2, y0, x0+d/2, y0+d); 
      g.drawLine(x0, y0+d/2, x0+d, y0+d/2);
      
      g.setFont(new Font((g.getFont()).getFontName(), Font.PLAIN, 10));
      g.drawString("S", x0+d/2, y0+d); g.drawString("N", x0+d/2, y0+10);
      g.drawString("E", x0+d-5, y0+d/2); g.drawString("W", x0+1, y0+d/2);
      g.setFont(new Font((g.getFont()).getFontName(), Font.PLAIN, 12));
  
      g.setColor (Color.RED);
      
      x0 = x0 + d/2; y0 = y0 + d/2; // circunference centre     
           
      Position pos; double dec, inc, r; int x=0, y=0;
      Colormap colors = new Colormap(); int posCol;
      
      for(int i=0; i<directionsVector.size(); i++){

          posCol=(int)(i*64/directionsVector.size());
          g.setColor(colors.getCol(posCol));
    
          pos = (Position)directionsVector.get(i);
          dec = pos.getDec();
          inc = pos.getInc();

          dec = Math.toRadians(dec);
          inc = Math.toRadians(inc);
          r = d/2 * Math.sqrt(1 - Math.abs(Math.sin(inc)));
          x = (int) Math.round(r * Math.sin(dec));
          y = (int) Math.round(r * Math.cos(dec));

          if(inc > 0)
              g.fillOval(x+x0-d/100, -y+y0-d/100, d/50, d/50); // lower hemisphere
          else
              g.drawOval(x+x0-d/100, -y+y0-d/100, d/50-1, d/50-1); // upper hemisphere
 
       }

      Vector fishmean = Statistics.fisherMean(directionsVector);
          pos = (Position)(fishmean).get(0);
          r = d/2 * Math.sqrt(1 - Math.abs(Math.sin(Math.toRadians(pos.getInc()))));
          x = (int) Math.round(r * Math.sin(Math.toRadians(pos.getDec())));
          y = (int) Math.round(r * Math.cos(Math.toRadians(pos.getDec())));
          g.setColor(Color.BLACK);
          g.fillOval(x+x0-d/80, -y+y0-d/80, d/40, d/40); g.drawOval(x+x0-d/80, -y+y0-d/80, d/40, d/40);
          pos.round();
          String textData = "Mean demagnetization step: "+meanStep+"\nMean direction (dec,inc,k,a95,n):\n" + (int)pos.getDec() + ", " + (int)pos.getInc() + ", " + fishmean.get(4) + ", " + fishmean.get(5) + ", " + fishmean.get(14) + ")";
          textArea.setFont(new Font((g.getFont()).getFontName(), Font.PLAIN, 10));
          textArea.setText(textData);

    }
    
    private void legend(){ //pinto la leyenda de colores
 
        Graphics g=legendPanel.getGraphics();
        legendPanel.paint(g);
        g.setFont(new Font((g.getFont()).getFontName(), Font.PLAIN, 10));  
        
        Colormap colors = new Colormap();
        int posCol; 
       
        int Y = legendPanel.getHeight()-20;
        int x0 = 10; int y0 = 15; int d = 5; int L = 0;
        
        for(int i=0; i<names.size(); i = (int)(i+1+Math.ceil(names.size()/20))){
            //System.out.println("i: "+i);
            posCol=(int)(i*64/names.size());

            g.setColor(colors.getCol(posCol));
            L=i*Y/names.size();
            g.fillOval(x0, y0+L, d, d);
            g.drawString(""+names.get(i),x0+10,y0+L+5);
        }

    }
    
    public void paintComponent(Graphics g) {
        g=logoPan.getGraphics();
        ImageIcon imag = new ImageIcon("logoVPD.jpg");     
        g.drawImage(imag.getImage(), 0, 0,  imag.getIconWidth() ,  imag.getIconHeight(), null);
        logoPan.paintComponents(g);
    }
        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JToggleButton RDButton;
    private javax.swing.JPanel dirPanel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JPanel legendPanel;
    private javax.swing.JPanel linearityPanel;
    private javax.swing.JPanel logoPan;
    private javax.swing.JPanel logoPanel;
    private javax.swing.JPanel logoPanel1;
    private javax.swing.JPanel logoPanel2;
    private javax.swing.JPanel logoPanel3;
    private javax.swing.JPanel meanLinPanel;
    private javax.swing.JTextArea textArea;
    // End of variables declaration//GEN-END:variables
    
}
