/*
 * VDWindow.java
 */

package paldirvd;

import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.util.Arrays;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;


public class VDWindow extends javax.swing.JFrame {
    
    private static String RESULTANT = "R";
    private static String DIFFERENCE = "D";
    private static String PLANE = "P";
    private static String VECTOR = "V";

    private static int SIZE_TEXT = 80;
    private static int SIZE_TEXT2 = 50;
    private static Color COLOR1=new Color(21,57,167), COLOR2=new Color(134,207,248), COLOR3=new Color(16,0,105), COLOR4=new Color(222,253,28);
    
    private Vector vds, vdsTc, vdsFilt, vdsTcFilt, site;
    private boolean filt = false, tc = false, drilling = false, presentField = false;
    private double stepIni, stepEnd, minInt, maxInt, minMad, maxMad;
    private int numSteps;
    private Position present_field=null;
    
    /** Creates new form VDWindow */
    public VDWindow(Vector v, Vector v2, Vector finalSite) {
        initComponents();
        //setExtendedState(MAXIMIZED_BOTH);
        vds = v;
        vdsFilt = vds;
        vdsTc = v2;
        vdsTcFilt = vdsTc;
        site = finalSite;
        initFilterParams();
        FilterButton.setRequestFocusEnabled(false);
        plot();
        
        FilterButton.addKeyListener(new ComponentListener());
        PlotAllButton.addKeyListener(new ComponentListener());
        tcButton.addKeyListener(new ComponentListener());
        RVText.addKeyListener(new ComponentListener());
        RPText.addKeyListener(new ComponentListener());
        DVText.addKeyListener(new ComponentListener());
        DPText.addKeyListener(new ComponentListener());
        VText.addKeyListener(new ComponentListener());
        PText.addKeyListener(new ComponentListener());
        
        this.setTitle("Virtual Paleomagnetic Directions and Circles");
    }
    
      

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        RVPanel = new javax.swing.JPanel();
        RVLabel = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        RVText = new javax.swing.JTextArea();
        DVPanel = new javax.swing.JPanel();
        DVLabel = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        DVText = new javax.swing.JTextArea();
        VPanel = new javax.swing.JPanel();
        VLabel = new javax.swing.JLabel();
        jScrollPane3 = new javax.swing.JScrollPane();
        VText = new javax.swing.JTextArea();
        RPPanel = new javax.swing.JPanel();
        RPLabel = new javax.swing.JLabel();
        jScrollPane4 = new javax.swing.JScrollPane();
        RPText = new javax.swing.JTextArea();
        DPPanel = new javax.swing.JPanel();
        DPLabel = new javax.swing.JLabel();
        jScrollPane5 = new javax.swing.JScrollPane();
        DPText = new javax.swing.JTextArea();
        PPanel = new javax.swing.JPanel();
        PLabel = new javax.swing.JLabel();
        jScrollPane6 = new javax.swing.JScrollPane();
        PText = new javax.swing.JTextArea();
        FilterButton = new javax.swing.JButton();
        PlotAllButton = new javax.swing.JButton();
        tcButton = new javax.swing.JButton();
        tcButton1 = new javax.swing.JButton();
        LegendPanel = new javax.swing.JPanel();
        logoPanel = new javax.swing.JPanel();
        presentFieldButton = new javax.swing.JButton();
        drillingButton = new javax.swing.JToggleButton();
        decIncButton = new javax.swing.JButton();
        jMenuBar21 = new javax.swing.JMenuBar();
        jMenu21 = new javax.swing.JMenu();
        SaveFiltOption20 = new javax.swing.JMenuItem();
        SaveAllOption20 = new javax.swing.JMenuItem();
        SaveStatistics = new javax.swing.JMenuItem();

        setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        setExtendedState(MAXIMIZED_BOTH);
        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                replot(evt);
            }
        });

        RVPanel.setMinimumSize(new java.awt.Dimension(200, 265));
        RVPanel.setName("RESULTANT DIRECTIONS"); // NOI18N
        RVPanel.setPreferredSize(new java.awt.Dimension(300, 365));
        RVPanel.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
        RVPanel.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                dataPoint(evt, RVPanel, RVLabel);
            }
        });

        RVLabel.setBackground(getBackground());
        RVLabel.setForeground(new java.awt.Color(102, 102, 102));

        jScrollPane1.setBackground(javax.swing.UIManager.getDefaults().getColor("Label.background"));
        jScrollPane1.setBorder(null);
        jScrollPane1.setForeground(javax.swing.UIManager.getDefaults().getColor("Label.background"));
        jScrollPane1.setMinimumSize(new java.awt.Dimension(200, 80));
        jScrollPane1.setPreferredSize(new java.awt.Dimension(300, 80));

        RVText.setBackground(javax.swing.UIManager.getDefaults().getColor("Label.background"));
        RVText.setColumns(20);
        RVText.setEditable(false);
        RVText.setFont(new java.awt.Font("Lucida Grande", 0, 10));
        RVText.setForeground(java.awt.Color.darkGray);
        RVText.setRows(5);
        jScrollPane1.setViewportView(RVText);

        org.jdesktop.layout.GroupLayout RVPanelLayout = new org.jdesktop.layout.GroupLayout(RVPanel);
        RVPanel.setLayout(RVPanelLayout);
        RVPanelLayout.setHorizontalGroup(
            RVPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(RVPanelLayout.createSequentialGroup()
                .add(RVLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 147, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(191, Short.MAX_VALUE))
            .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 338, Short.MAX_VALUE)
        );
        RVPanelLayout.setVerticalGroup(
            RVPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(RVPanelLayout.createSequentialGroup()
                .addContainerGap(253, Short.MAX_VALUE)
                .add(RVLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(18, 18, 18)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
        );

        DVPanel.setFocusable(false);
        DVPanel.setMinimumSize(new java.awt.Dimension(200, 265));
        DVPanel.setName("DIFERENCE DIRECTIONS"); // NOI18N
        DVPanel.setPreferredSize(new java.awt.Dimension(300, 365));
        DVPanel.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
        DVPanel.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                dataPoint(evt, DVPanel, DVLabel);
            }
        });

        DVLabel.setBackground(getBackground());
        DVLabel.setForeground(new java.awt.Color(102, 102, 102));

        jScrollPane2.setBackground(javax.swing.UIManager.getDefaults().getColor("Label.background"));
        jScrollPane2.setBorder(null);
        jScrollPane2.setForeground(javax.swing.UIManager.getDefaults().getColor("Label.background"));
        jScrollPane2.setMinimumSize(new java.awt.Dimension(200, 80));
        jScrollPane2.setPreferredSize(new java.awt.Dimension(300, 80));

        DVText.setBackground(javax.swing.UIManager.getDefaults().getColor("Label.background"));
        DVText.setColumns(20);
        DVText.setEditable(false);
        DVText.setFont(new java.awt.Font("Lucida Grande", 0, 10));
        DVText.setForeground(java.awt.Color.darkGray);
        DVText.setRows(5);
        DVText.setRequestFocusEnabled(false);
        jScrollPane2.setViewportView(DVText);

        org.jdesktop.layout.GroupLayout DVPanelLayout = new org.jdesktop.layout.GroupLayout(DVPanel);
        DVPanel.setLayout(DVPanelLayout);
        DVPanelLayout.setHorizontalGroup(
            DVPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(DVPanelLayout.createSequentialGroup()
                .add(DVLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 147, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(191, Short.MAX_VALUE))
            .add(jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 338, Short.MAX_VALUE)
        );
        DVPanelLayout.setVerticalGroup(
            DVPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(DVPanelLayout.createSequentialGroup()
                .addContainerGap(253, Short.MAX_VALUE)
                .add(DVLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(18, 18, 18)
                .add(jScrollPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
        );

        VPanel.setFocusable(false);
        VPanel.setMinimumSize(new java.awt.Dimension(200, 265));
        VPanel.setName("ALL DIRECTIONS"); // NOI18N
        VPanel.setPreferredSize(new java.awt.Dimension(300, 365));
        VPanel.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
        VPanel.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                dataPoint(evt, VPanel, VLabel);
            }
        });

        VLabel.setBackground(getBackground());
        VLabel.setForeground(new java.awt.Color(102, 102, 102));

        jScrollPane3.setBackground(javax.swing.UIManager.getDefaults().getColor("Label.background"));
        jScrollPane3.setBorder(null);
        jScrollPane3.setForeground(javax.swing.UIManager.getDefaults().getColor("Label.background"));
        jScrollPane3.setMinimumSize(new java.awt.Dimension(200, 80));
        jScrollPane3.setPreferredSize(new java.awt.Dimension(300, 80));

        VText.setBackground(javax.swing.UIManager.getDefaults().getColor("Label.background"));
        VText.setColumns(20);
        VText.setEditable(false);
        VText.setFont(new java.awt.Font("Lucida Grande", 0, 10));
        VText.setForeground(java.awt.Color.darkGray);
        VText.setRows(5);
        jScrollPane3.setViewportView(VText);

        org.jdesktop.layout.GroupLayout VPanelLayout = new org.jdesktop.layout.GroupLayout(VPanel);
        VPanel.setLayout(VPanelLayout);
        VPanelLayout.setHorizontalGroup(
            VPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(VPanelLayout.createSequentialGroup()
                .add(VLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 147, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(192, Short.MAX_VALUE))
            .add(jScrollPane3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 339, Short.MAX_VALUE)
        );
        VPanelLayout.setVerticalGroup(
            VPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(VPanelLayout.createSequentialGroup()
                .addContainerGap(253, Short.MAX_VALUE)
                .add(VLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(18, 18, 18)
                .add(jScrollPane3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
        );

        RPPanel.setFocusable(false);
        RPPanel.setMinimumSize(new java.awt.Dimension(200, 235));
        RPPanel.setName("RESULTANT CIRCLES"); // NOI18N
        RPPanel.setPreferredSize(new java.awt.Dimension(300, 335));
        RPPanel.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
        RPPanel.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                dataPoint(evt, RPPanel, RPLabel);
            }
        });

        RPLabel.setBackground(getBackground());
        RPLabel.setForeground(new java.awt.Color(102, 102, 102));

        jScrollPane4.setBackground(javax.swing.UIManager.getDefaults().getColor("Label.background"));
        jScrollPane4.setBorder(null);
        jScrollPane4.setForeground(javax.swing.UIManager.getDefaults().getColor("Label.background"));
        jScrollPane4.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_NEVER);
        jScrollPane4.setMinimumSize(new java.awt.Dimension(200, 50));
        jScrollPane4.setPreferredSize(new java.awt.Dimension(300, 50));

        RPText.setBackground(javax.swing.UIManager.getDefaults().getColor("Label.background"));
        RPText.setColumns(20);
        RPText.setEditable(false);
        RPText.setFont(new java.awt.Font("Lucida Grande", 0, 10));
        RPText.setForeground(java.awt.Color.darkGray);
        RPText.setRows(5);
        RPText.setPreferredSize(new java.awt.Dimension(180, 35));
        jScrollPane4.setViewportView(RPText);

        org.jdesktop.layout.GroupLayout RPPanelLayout = new org.jdesktop.layout.GroupLayout(RPPanel);
        RPPanel.setLayout(RPPanelLayout);
        RPPanelLayout.setHorizontalGroup(
            RPPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(RPPanelLayout.createSequentialGroup()
                .add(RPLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 147, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(192, Short.MAX_VALUE))
            .add(jScrollPane4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 339, Short.MAX_VALUE)
        );
        RPPanelLayout.setVerticalGroup(
            RPPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(RPPanelLayout.createSequentialGroup()
                .addContainerGap(262, Short.MAX_VALUE)
                .add(RPLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jScrollPane4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
        );

        DPPanel.setFocusable(false);
        DPPanel.setMinimumSize(new java.awt.Dimension(200, 235));
        DPPanel.setName("DIFERENCE CIRCLES"); // NOI18N
        DPPanel.setPreferredSize(new java.awt.Dimension(300, 335));
        DPPanel.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
        DPPanel.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                dataPoint(evt, DPPanel, DPLabel);
            }
        });

        DPLabel.setBackground(getBackground());
        DPLabel.setForeground(new java.awt.Color(102, 102, 102));

        jScrollPane5.setBackground(javax.swing.UIManager.getDefaults().getColor("Label.background"));
        jScrollPane5.setBorder(null);
        jScrollPane5.setForeground(javax.swing.UIManager.getDefaults().getColor("Label.background"));
        jScrollPane5.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_NEVER);
        jScrollPane5.setMinimumSize(new java.awt.Dimension(200, 50));
        jScrollPane5.setPreferredSize(new java.awt.Dimension(300, 50));

        DPText.setBackground(javax.swing.UIManager.getDefaults().getColor("Label.background"));
        DPText.setColumns(20);
        DPText.setEditable(false);
        DPText.setFont(new java.awt.Font("Lucida Grande", 0, 10));
        DPText.setForeground(java.awt.Color.darkGray);
        DPText.setRows(5);
        DPText.setPreferredSize(new java.awt.Dimension(180, 35));
        jScrollPane5.setViewportView(DPText);

        org.jdesktop.layout.GroupLayout DPPanelLayout = new org.jdesktop.layout.GroupLayout(DPPanel);
        DPPanel.setLayout(DPPanelLayout);
        DPPanelLayout.setHorizontalGroup(
            DPPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(DPPanelLayout.createSequentialGroup()
                .add(DPLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 147, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(192, Short.MAX_VALUE))
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jScrollPane5, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 339, Short.MAX_VALUE)
        );
        DPPanelLayout.setVerticalGroup(
            DPPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(DPPanelLayout.createSequentialGroup()
                .addContainerGap(262, Short.MAX_VALUE)
                .add(DPLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jScrollPane5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
        );

        PPanel.setFocusable(false);
        PPanel.setMinimumSize(new java.awt.Dimension(200, 235));
        PPanel.setName("ALL CIRCLES"); // NOI18N
        PPanel.setPreferredSize(new java.awt.Dimension(300, 335));
        PPanel.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
        PPanel.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                dataPoint(evt, PPanel, PLabel);
            }
        });

        PLabel.setBackground(getBackground());
        PLabel.setForeground(new java.awt.Color(102, 102, 102));

        jScrollPane6.setBackground(javax.swing.UIManager.getDefaults().getColor("Label.background"));
        jScrollPane6.setBorder(null);
        jScrollPane6.setForeground(javax.swing.UIManager.getDefaults().getColor("Label.background"));
        jScrollPane6.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_NEVER);
        jScrollPane6.setMinimumSize(new java.awt.Dimension(200, 50));
        jScrollPane6.setPreferredSize(new java.awt.Dimension(300, 50));

        PText.setBackground(javax.swing.UIManager.getDefaults().getColor("Label.background"));
        PText.setColumns(20);
        PText.setEditable(false);
        PText.setFont(new java.awt.Font("Lucida Grande", 0, 10));
        PText.setForeground(java.awt.Color.darkGray);
        PText.setRows(5);
        PText.setPreferredSize(new java.awt.Dimension(180, 35));
        jScrollPane6.setViewportView(PText);

        org.jdesktop.layout.GroupLayout PPanelLayout = new org.jdesktop.layout.GroupLayout(PPanel);
        PPanel.setLayout(PPanelLayout);
        PPanelLayout.setHorizontalGroup(
            PPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(PPanelLayout.createSequentialGroup()
                .add(PLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 147, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(194, Short.MAX_VALUE))
            .add(jScrollPane6, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 341, Short.MAX_VALUE)
        );
        PPanelLayout.setVerticalGroup(
            PPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(PPanelLayout.createSequentialGroup()
                .addContainerGap(262, Short.MAX_VALUE)
                .add(PLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jScrollPane6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
        );

        FilterButton.setText("Filter");
        FilterButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                FilterButtonActionPerformed(evt);
            }
        });

        PlotAllButton.setText("All data");
        PlotAllButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                PlotAllButtonActionPerformed(evt);
            }
        });

        tcButton.setText("tc/ntc");
        tcButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tcButtonActionPerformed(evt);
            }
        });

        tcButton1.setText("tc/ntc");
        tcButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tcButtonActionPerformed(evt);
            }
        });

        LegendPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        org.jdesktop.layout.GroupLayout LegendPanelLayout = new org.jdesktop.layout.GroupLayout(LegendPanel);
        LegendPanel.setLayout(LegendPanelLayout);
        LegendPanelLayout.setHorizontalGroup(
            LegendPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 200, Short.MAX_VALUE)
        );
        LegendPanelLayout.setVerticalGroup(
            LegendPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 78, Short.MAX_VALUE)
        );

        logoPanel.setPreferredSize(new java.awt.Dimension(170, 48));

        org.jdesktop.layout.GroupLayout logoPanelLayout = new org.jdesktop.layout.GroupLayout(logoPanel);
        logoPanel.setLayout(logoPanelLayout);
        logoPanelLayout.setHorizontalGroup(
            logoPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 170, Short.MAX_VALUE)
        );
        logoPanelLayout.setVerticalGroup(
            logoPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 48, Short.MAX_VALUE)
        );

        presentFieldButton.setText("Present Field");
        presentFieldButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                presentFieldButtonActionPerformed(evt);
            }
        });

        drillingButton.setText("drilling");
        drillingButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                drillingButtonActionPerformed(evt);
            }
        });

        decIncButton.setText("Dec/Inc Window");
        decIncButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                decIncButtonActionPerformed(evt);
            }
        });

        jMenu21.setText("File");

        SaveFiltOption20.setText("Save filt vds");
        SaveFiltOption20.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SaveFiltOptionActionPerformed(evt);
            }
        });
        jMenu21.add(SaveFiltOption20);

        SaveAllOption20.setText("Save all vds");
        SaveAllOption20.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SaveAllOptionActionPerformed(evt);
            }
        });
        jMenu21.add(SaveAllOption20);

        SaveStatistics.setText("Save statistics (filt vds)");
        SaveStatistics.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SaveStatisticsSaveAllOptionActionPerformed(evt);
            }
        });
        jMenu21.add(SaveStatistics);

        jMenuBar21.add(jMenu21);

        setJMenuBar(jMenuBar21);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(10, 10, 10)
                        .add(RVPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 338, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(DVPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 338, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(VPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 339, Short.MAX_VALUE))
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(RPPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 339, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(DPPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 339, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(PPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 341, Short.MAX_VALUE))
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(logoPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(48, 48, 48)
                                .add(FilterButton)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(PlotAllButton)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(tcButton)
                                .add(50, 50, 50)
                                .add(drillingButton)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(presentFieldButton))
                            .add(layout.createSequentialGroup()
                                .add(106, 106, 106)
                                .add(decIncButton)))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 77, Short.MAX_VALUE)
                        .add(LegendPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, DVPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 373, Short.MAX_VALUE)
                    .add(RVPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 373, Short.MAX_VALUE)
                    .add(VPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 373, Short.MAX_VALUE))
                .add(11, 11, 11)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(RPPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 340, Short.MAX_VALUE)
                    .add(DPPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 340, Short.MAX_VALUE)
                    .add(PPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 340, Short.MAX_VALUE))
                .add(12, 12, 12)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(layout.createSequentialGroup()
                        .add(decIncButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(FilterButton)
                            .add(PlotAllButton)
                            .add(tcButton)
                            .add(presentFieldButton)
                            .add(drillingButton)))
                    .add(logoPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(LegendPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
                              
     class ComponentListener extends KeyAdapter
     {
        public void keyPressed(KeyEvent e){
           if (e.getKeyCode() == KeyEvent.VK_S){
	        if (e.isMetaDown()){
                	//System.out.println("Meta + s : save");
                        if(filt)
                            save(vdsFilt);
                        else
                            save(vds);
                 }
           }
           if (e.getKeyCode() == KeyEvent.VK_W){
	        if (e.isMetaDown()){
                	//System.out.println("Meta + w : close ");
                        dispose();
                }
           }
        }  
     }
         
    private void FilterButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_FilterButtonActionPerformed
    
        filt = true;      
        FilterWindow filtView = new FilterWindow(this, String.valueOf(stepIni), String.valueOf(stepEnd), String.valueOf(numSteps), String.valueOf(minInt), String.valueOf(maxInt), String.valueOf(minMad), String.valueOf(maxMad));
        filtView.setVisible(true);
       
    }//GEN-LAST:event_FilterButtonActionPerformed

    private void PlotAllButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_PlotAllButtonActionPerformed
        filt = false;
        //initFilterParams();
        plot();
    }//GEN-LAST:event_PlotAllButtonActionPerformed

    private void tcButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tcButtonActionPerformed
        tc = !tc;
        plot();
}//GEN-LAST:event_tcButtonActionPerformed

    private void SaveFiltOptionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SaveFiltOptionActionPerformed
        if(tc)
            save(vdsTcFilt);
        else
            save(vdsFilt);
}//GEN-LAST:event_SaveFiltOptionActionPerformed
    private void save(Vector v){
        JFileChooser chooser = new JFileChooser();
        chooser.changeToParentDirectory();
        int returnVal = chooser.showSaveDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            String fileName = chooser.getSelectedFile().getPath();
            ImportExport.writeVD(fileName, v, tc, false);
        } 
    }

    private void saveStatistics(){
        JFileChooser chooser = new JFileChooser();
        chooser.changeToParentDirectory();
        int returnVal = chooser.showSaveDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            String fileName = chooser.getSelectedFile().getPath();
            Vector v = vdsFilt;
            if(tc)
                v = vdsTcFilt;
            ImportExport.writeStatistics(fileName, v, tc);
        }
    }
    
    private void replot(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_replot
        plot();
    }//GEN-LAST:event_replot

    private void SaveAllOptionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SaveAllOptionActionPerformed
        if(tc)
            save(vdsTc);
        else
            save(vds);
    }//GEN-LAST:event_SaveAllOptionActionPerformed

    private void drillingButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_drillingButtonActionPerformed
       drilling = !drilling;
       plot();
    }//GEN-LAST:event_drillingButtonActionPerformed

    private void presentFieldButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_presentFieldButtonActionPerformed
       ActualFieldWindow1 actualFieldWindow1 = new ActualFieldWindow1(this);
       actualFieldWindow1.setVisible(true);
    }//GEN-LAST:event_presentFieldButtonActionPerformed

    private void SaveStatisticsSaveAllOptionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SaveStatisticsSaveAllOptionActionPerformed
        saveStatistics();
    }//GEN-LAST:event_SaveStatisticsSaveAllOptionActionPerformed

    private void decIncButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_decIncButtonActionPerformed
        Vector vector;
        if(tc) 
            vector=vdsTcFilt;
        else
            vector=vdsFilt;
        DecIncWindow decIncView = new DecIncWindow(vector);
        decIncView.setVisible(true);        // TODO add your handling code here:
}//GEN-LAST:event_decIncButtonActionPerformed

    public void setActualField(Position actualField){
        if (actualField == null){
            //System.out.println("Present field is null");
            presentField=false;
        }else{
            //System.out.println("Present field: " + actualField.getDec() + ", " + actualField.getInc());
            presentField=true;
        }present_field = actualField;
        plot();
    }

     private void dataPoint(java.awt.event.MouseEvent evt, JPanel panel, JLabel label) {
        
        double d, x, y, dec = Math.PI/2, inc = 0; 
               
        Point point = panel.getMousePosition();
                 
        Dimension tam = panel.getSize();  
        int sizeText = SIZE_TEXT;
        if(panel == RPPanel || panel == DPPanel || panel == PPanel)
            sizeText = SIZE_TEXT2;
        d = Math.min( tam.width,tam.height - sizeText ) - 2; 
        x = (point.getX() - tam.width/2 + 1) / d * 2;
        y = ((tam.height-sizeText)/2 - 1 - point.getY()) / d * 2;
        if (y != 0)
            dec = Math.atan(x/y);
        if(dec<0)
            dec = dec + Math.PI;
        if(x<0)
            dec = dec + Math.PI;
        if(Math.sin(dec) != 0)
            inc = Math.asin(1 - Math.pow(x / Math.sin(dec), 2));
        else
            inc = Math.asin(1 - Math.pow(y / Math.cos(dec), 2));
        dec = Math.round(Math.toDegrees(dec));
        inc = Math.round(Math.toDegrees(inc));
        if(inc > 0){
            label.setVisible(true);
            String text = "dec: " + (int)dec + ", inc: " + (int)inc;
            label.setText(text);
        }else{
            label.setVisible(false);
            this.repaint();
        }
    }
     
     private void stereonet(JPanel panel,JTextArea textArea, String planeLine, String resDif, boolean allResDif) {
         
      Graphics2D g = (Graphics2D) panel.getGraphics();
      panel.paint(g);

      Dimension tam = panel.getSize(); // plotPanel size
      int sizeText = SIZE_TEXT;
      if(panel == RPPanel || panel == DPPanel || panel == PPanel)
          sizeText = SIZE_TEXT2;
      int d = Math.min( tam.width,tam.height-sizeText ) - 2; // diameter
      int x0 = (tam.width - d) / 2 + 1;
      int y0 = (tam.height - sizeText - d) / 2 + 1;

      if(panel.equals(RVPanel)){
          g.drawString("RESULTANT (inclor)", TOP_ALIGNMENT + 15, TOP_ALIGNMENT + 15);
          g.drawString("DIRECTIONS", TOP_ALIGNMENT + 15, TOP_ALIGNMENT + 30);
      }
      if(panel.equals(DVPanel)){
          g.drawString("DIFFERENCE (exclor)", TOP_ALIGNMENT + 15, TOP_ALIGNMENT + 15);
          g.drawString("DIRECTIONS", TOP_ALIGNMENT + 15, TOP_ALIGNMENT + 30);
      }
      if(panel.equals(VPanel)){
          g.drawString("ALL", TOP_ALIGNMENT + 15, TOP_ALIGNMENT + 15);
          g.drawString("DIRECTIONS", TOP_ALIGNMENT + 15, TOP_ALIGNMENT + 30);
      }
      if(panel.equals(RPPanel)){
          g.drawString("RESULTANT (inclor)", TOP_ALIGNMENT + 15, TOP_ALIGNMENT + 15);
          g.drawString("CIRCLES", TOP_ALIGNMENT + 15, TOP_ALIGNMENT + 30);
      }
      if(panel.equals(DPPanel)){
          g.drawString("DIFFERENCE (exclor)", TOP_ALIGNMENT + 15, TOP_ALIGNMENT + 15);
          g.drawString("CIRCLES", TOP_ALIGNMENT + 15, TOP_ALIGNMENT + 30);
      }
      if(panel.equals(PPanel)){
          g.drawString("ALL", TOP_ALIGNMENT + 15, TOP_ALIGNMENT + 15);
          g.drawString("CIRCLES", TOP_ALIGNMENT + 15, TOP_ALIGNMENT + 30);
      }
      if(tc)
          g.drawString("TC", TOP_ALIGNMENT + 15, TOP_ALIGNMENT + 45);
      else
          g.drawString("NO TC", TOP_ALIGNMENT + 15, TOP_ALIGNMENT + 45);
      
      g.setColor (Color.GRAY);
      g.drawOval(x0, y0, d, d);// border circunference
      g.drawLine(x0+d/2, y0, x0+d/2, y0+d); 
      g.drawLine(x0, y0+d/2, x0+d, y0+d/2);
      g.setColor (Color.RED);
      
      x0 = x0 + d/2; y0 = y0 + d/2; // circunference centre     
           
      double dec, inc, r; int x=0, y=0; VD vd; Vector meanPos = new Vector();

      //DRILLING POSITION
      Core core, corePresentField; Position present_field_tc;
      g.setColor (new Color(0,150,0));
      for(int i=0; i<site.size(); i++){
      core = (Core)site.get(i);
      if(drilling){
        if(tc){
          dec = Math.toRadians(core.getTrendCorrected());
          inc = Math.toRadians(core.getPlungeCorrected());
        }else{
          dec = Math.toRadians(core.getTrend());
          inc = Math.toRadians(core.getPlunge());
        }
        r = d/2 * Math.sqrt(1 - Math.abs(Math.sin(inc)));
        x = (int) Math.round(r * Math.sin(dec));
        y = (int) Math.round(r * Math.cos(dec));
        if(inc>0)
            g.fillOval(x+x0-d/100, -y+y0-d/100, d/30, d/30);
        else
            g.drawOval(x+x0-d/100, -y+y0-d/100, d/30, d/30);
        }
      }
      //PRESENT FIELD
      g.setColor (new Color(0,50,0));
      if(presentField){
          //System.out.println("Present_field dec: "+present_field.getDec()+", inc:"+present_field.getInc());
       if(tc){
          Step stepPresentField = new Step(0,present_field);
          for(int i=0; i<site.size(); i++){
            core = (Core)site.get(i);
            corePresentField = new Core(core.getName(), core.getComment(), core.getTrend(), core.getPlunge(), core.getStrike(), core.getDip(), core.getVol());
            corePresentField.setSteps(new Vector()); corePresentField.setStepN(stepPresentField);
            corePresentField = corePresentField.beddingCorrection();
            present_field_tc = (corePresentField.getStepN(0)).getPos();
            dec = Math.toRadians(present_field_tc.getDec());
            inc = Math.toRadians(present_field_tc.getInc());
            r = d/2 * Math.sqrt(1 - Math.abs(Math.sin(inc)));
            x = (int) Math.round(r * Math.sin(dec));
            y = (int) Math.round(r * Math.cos(dec));
            if (inc>0)
               g.fillOval(x+x0-d/100, -y+y0-d/100, d/30, d/30);
            else
               g.drawOval(x+x0-d/100, -y+y0-d/100, d/30, d/30);
          }
        }else{
          dec = Math.toRadians(present_field.getDec());
          inc = Math.toRadians(present_field.getInc());
          r = d/2 * Math.sqrt(1 - Math.abs(Math.sin(inc)));
          x = (int) Math.round(r * Math.sin(dec));
          y = (int) Math.round(r * Math.cos(dec));
          if (inc>0)
              g.fillOval(x+x0-d/100, -y+y0-d/100, d/30, d/30);
          else
              g.drawOval(x+x0-d/100, -y+y0-d/100, d/30, d/30);
       }
      }
      g.setColor (Color.RED);
      
//      filter();
      
      Vector v;
      if(filt)
          if(tc)
            v = vdsTcFilt;
          else
            v = vdsFilt;
      else
          if(tc)
              v = vdsTc;
          else
              v = vds;
      
      for(int i=0; i<v.size(); i++){
          vd = (VD) v.get(i);
          if(vd.getPlaneLine().equals(planeLine)){
              if(allResDif || (!allResDif && vd.getResDif().equals(resDif))){
                  dec = vd.getPos().getDec();
                  inc = vd.getPos().getInc();
                  dec = Math.toRadians(dec);
                  inc = Math.toRadians(inc);
                  r = d/2 * Math.sqrt(1 - Math.abs(Math.sin(inc)));
                  x = (int) Math.round(r * Math.sin(dec));
                  y = (int) Math.round(r * Math.cos(dec));

                  if(inc > 0)
                      g.fillOval(x+x0-d/100, -y+y0-d/100, d/50, d/50); // lower hemisphere
                  else
                      g.drawOval(x+x0-d/140, -y+y0-d/140, d/70, d/70); // upper hemisphere
                  
                  meanPos.add(vd.getPos());
              }
          }

       }
       //FISHER
       Position pos;
       String textData = "";
       if(planeLine.equals(VECTOR)){
          textData = "FISHER (dec, inc, k, a95)";
           //all 
          //System.out.println();
          //System.out.println(panel.getName());
          Vector fishmean = Statistics.fisherMean(meanPos);
          /* 
          pos = (Position)(fishmean).get(0);
          r = d/2 * Math.sqrt(1 - Math.abs(Math.sin(Math.toRadians(pos.getInc()))));
          x = (int) Math.round(r * Math.sin(Math.toRadians(pos.getDec())));
          y = (int) Math.round(r * Math.cos(Math.toRadians(pos.getDec())));
          g.setColor (new Color(0,250,0));
          g.fillOval(x+x0-d/90, -y+y0-d/90, d/45, d/45);
          pos.round();
          textData = textData + "\nAll: " + (int)pos.getDec() + ", " + (int)pos.getInc() + ", " + fishmean.get(4) + ", " + fishmean.get(5);
         */
          //positive inclination
          pos = (Position)(fishmean).get(1);
          r = d/2 * Math.sqrt(1 - Math.abs(Math.sin(Math.toRadians(pos.getInc()))));
          x = (int) Math.round(r * Math.sin(Math.toRadians(pos.getDec())));
          y = (int) Math.round(r * Math.cos(Math.toRadians(pos.getDec())));
          g.setColor (COLOR1);
          g.fillOval(x+x0-d/70, -y+y0-d/70, d/35, d/35);
          g.setColor (Color.BLACK); g.drawOval(x+x0-d/70, -y+y0-d/70, d/35, d/35);
          pos.round();
          textData = textData + "\nPos: " + (int)pos.getDec() + ", " + (int)pos.getInc() + ", " + fishmean.get(6) + ", " + fishmean.get(7) + " (n= " + fishmean.get(8) + ")";

          //negative inclination
          pos = (Position)(fishmean).get(2);
          r = d/2 * Math.sqrt(1 - Math.abs(Math.sin(Math.toRadians(pos.getInc()))));
          x = (int) Math.round(r * Math.sin(Math.toRadians(pos.getDec())));
          y = (int) Math.round(r * Math.cos(Math.toRadians(pos.getDec())));
          g.setColor (COLOR2);
          g.fillOval(x+x0-d/70, -y+y0-d/70, d/35, d/35);
          g.setColor (Color.BLACK); g.drawOval(x+x0-d/70, -y+y0-d/70, d/35, d/35);
          pos.round();
          textData = textData + "\nNeg: " + (int)pos.getDec() + ", " + (int)pos.getInc() + ", " + fishmean.get(9) + ", " + fishmean.get(10) + " (n= " + fishmean.get(11) + ")";
          //ALL, NEGATIVE INCLINATION --> ROTATE
          pos = (Position)(fishmean).get(3);
          r = d/2 * Math.sqrt(1 - Math.abs(Math.sin(Math.toRadians(pos.getInc()))));
          x = (int) Math.round(r * Math.sin(Math.toRadians(pos.getDec())));
          y = (int) Math.round(r * Math.cos(Math.toRadians(pos.getDec())));
          g.setColor (COLOR3);
          g.fillOval(x+x0-d/70, -y+y0-d/70, d/35, d/35);
          g.setColor (Color.BLACK); g.drawOval(x+x0-d/70, -y+y0-d/70, d/35, d/35);
          pos.round();
          textData = textData + "\nPos+ Neg-: " + (int)pos.getDec() + ", " + (int)pos.getInc() + ", " + fishmean.get(12) + ", " + fishmean.get(13) + " (n= " + fishmean.get(14) + ")";
          /* //All together: positive + negative
          pos = (Position)(fishmean).get(0);
          r = d/2 * Math.sqrt(1 - Math.abs(Math.sin(Math.toRadians(pos.getInc()))));
          x = (int) Math.round(r * Math.sin(Math.toRadians(pos.getDec())));
          y = (int) Math.round(r * Math.cos(Math.toRadians(pos.getDec())));
          g.setColor (new Color(0,250,0));
          g.fillOval(x+x0-d/70, -y+y0-d/70, d/35, d/35);
          pos.round();
          textData = textData + "\nAll: " + (int)pos.getDec() + ", " + (int)pos.getInc() + ", " + fishmean.get(4) + ", " + fishmean.get(5) + " (n= " + fishmean.get(14) + ")";
          */
       }
       //BINGHAM     
       textData = textData + "\nBINGHAM (e, dec, inc)\n";
       //System.out.println("BINGHAM, " + panel.getName());
       Vector bingham = Statistics.bingham(meanPos);
       g.setColor (new Color(222,253,28));
       int j=1;
       for(int i=5; i>2; i--){             
          pos = (Position)bingham.get(i);
          r = d/2 * Math.sqrt(1 - Math.abs(Math.sin(Math.toRadians(pos.getInc()))));
          x = (int) Math.round(r * Math.sin(Math.toRadians(pos.getDec())));
          y = (int) Math.round(r * Math.cos(Math.toRadians(pos.getDec())));
          if(i==5){
              g.fillRect(x+x0-d/70, -y+y0-d/70, d/35, d/35);
              g.setColor (Color.BLACK); g.drawRect(x+x0-d/70, -y+y0-d/70, d/35, d/35); g.setColor (new Color(222,253,28));
          }
          if(i==4){
              int[] xpoints={x+x0-d/70,x+x0-d/70+d/35,x+x0}, ypoints={-y+y0-d/70,-y+y0-d/70,-y+y0-d/70-d/35};
              g.fillPolygon(xpoints, ypoints, 3);
              g.setColor (Color.BLACK); g.drawPolygon(xpoints, ypoints, 3); g.setColor (new Color(222,253,28));
          }
          if(i==3){
              g.fillOval(x+x0-d/70, -y+y0-d/70, d/35, d/35);
              g.setColor (Color.BLACK); g.drawOval(x+x0-d/70, -y+y0-d/70, d/35, d/35); g.setColor (new Color(222,253,28));
          }

          pos.round();
          textData = textData + "(" + j + ") " + bingham.get(i-3) + ", " + (int)pos.getDec() + ", " + (int)pos.getInc() + "; ";
          j++;
       }
       //Write data
       textArea.setText(textData);
     }

     public void paint(Graphics g){
         super.paint(getGraphics());
         paintComponent(g);
         plot();
     }
     
     private void plot(){
         stereonet(RVPanel, RVText, VECTOR, RESULTANT, false);
         stereonet(DVPanel, DVText, VECTOR, DIFFERENCE, false);
         stereonet(VPanel, VText, VECTOR, "", true);
         stereonet(RPPanel, RPText, PLANE, RESULTANT, false);
         stereonet(DPPanel, DPText, PLANE, DIFFERENCE, false);
         stereonet(PPanel, PText, PLANE, "", true);
         legendPlot();
     }
     
     public void legendPlot(){
         
      Graphics2D g = (Graphics2D) LegendPanel.getGraphics();
      LegendPanel.paint(g);
      
      g.setColor(Color.GRAY);
      g.drawString ("FISHER", 10 , 15 );
      g.drawString ("Pos", 24 , 30 );
      g.drawString ("Neg", 24 , 45 );
      g.drawString ("Pos+ Neg-", 24 , 60 );
      //g.drawString ("All", 24 , 75 );
      
      g.drawString ("BINGHAM", 130 , 15 );
      g.drawString ("1", 144 , 30 );
      g.drawString ("2", 144 , 45 );
      g.drawString ("3", 144 , 60 );
      
      g.setColor(COLOR1);
      g.fillOval(12, 22, 7 , 7 );
      g.setColor (Color.BLACK); g.drawOval(12, 22, 7, 7);

      g.setColor(COLOR2);
      g.fillOval(12, 38, 7 , 7 );
      g.setColor (Color.BLACK); g.drawOval(12, 38, 7, 7);

      g.setColor(COLOR3);
      g.fillOval(12, 53, 7 , 7 );
      g.setColor (Color.BLACK); g.drawOval(12, 53, 7, 7);

      
      g.setColor (COLOR4);
      g.fillRect(132, 22, 7, 7);
      g.setColor (Color.BLACK); g.drawRect(132, 22, 7, 7);

      g.setColor (COLOR4);
      int[] xpoints={132,139,135}, ypoints={44,44,37};
      g.fillPolygon(xpoints, ypoints, 3);
      g.setColor (Color.BLACK); g.drawPolygon(xpoints, ypoints, 3);

      g.setColor (COLOR4);
      g.fillOval(132, 53, 7, 7);
      g.setColor (Color.BLACK); g.drawOval(132, 53, 7, 7);

     }
     
     public void setFilterParams(double step_ini, double step_end, int num_steps, double min_int, double max_int, double min_mad,  double max_mad){
         stepIni = step_ini;
         stepEnd = step_end;
         numSteps = num_steps;
         minInt = min_int;
         maxInt = Math.round(max_int*10)/10d;
         minMad = min_mad;
         maxMad = max_mad;
         
         vdsFilt = VirtualDirections.Filter(vds, stepIni, stepEnd, numSteps, minInt, maxInt, minMad, maxMad);
         vdsTcFilt = VirtualDirections.Filter(vdsTc, stepIni, stepEnd, numSteps,minInt, maxInt, minMad, maxMad);
         plot();
     }
     
     private void initFilterParams(){
         double step_ini[] = new double[vds.size()];
         double step_end[] = new double[vds.size()];
         int num_steps[] = new int[vds.size()];
         double intensity[] = new double[vds.size()];
         double error[] = new double[vds.size()];
         for(int i=0; i<vds.size(); i++){
             step_ini[i] = ((VD)vds.get(i)).getStepIni();
             step_end[i] = ((VD)vds.get(i)).getStepEnd();
             num_steps[i] = ((VD)vds.get(i)).getNumSteps();
             intensity[i] = ((VD)vds.get(i)).getPos().getInt();
             error[i] = ((VD)vds.get(i)).getPos().getError();
         }
         Arrays.sort(step_ini);
         Arrays.sort(step_end);
         Arrays.sort(num_steps);
         Arrays.sort(intensity);
         Arrays.sort(error);
         stepIni = step_ini[0];
         stepEnd = step_end[vds.size()-1];
         numSteps = num_steps[0];
         minInt = intensity[0];
         maxInt = intensity[vds.size()-1]; maxInt = Math.round((maxInt+0.1)*10)/10d;
         minMad = error[0];
         maxMad = error[vds.size()-1];
     }

  public void paintComponent(Graphics g) {
        g=logoPanel.getGraphics();
        ImageIcon imag = new ImageIcon("logoVPD.jpg");
        g.drawImage(imag.getImage(), 0, 0,  imag.getIconWidth() ,  imag.getIconHeight(), null);
        logoPanel.paintComponents(g);
}

  public Vector getVdsFilt(){
      return vdsFilt;
  }
  public Vector getVds(){
      return vds;
  }
public Vector getFinalSite(){
    return site;
}

     
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel DPLabel;
    private javax.swing.JPanel DPPanel;
    private javax.swing.JTextArea DPText;
    private javax.swing.JLabel DVLabel;
    private javax.swing.JPanel DVPanel;
    private javax.swing.JTextArea DVText;
    private javax.swing.JButton FilterButton;
    private javax.swing.JPanel LegendPanel;
    private javax.swing.JLabel PLabel;
    private javax.swing.JPanel PPanel;
    private javax.swing.JTextArea PText;
    private javax.swing.JButton PlotAllButton;
    private javax.swing.JLabel RPLabel;
    private javax.swing.JPanel RPPanel;
    private javax.swing.JTextArea RPText;
    private javax.swing.JLabel RVLabel;
    private javax.swing.JPanel RVPanel;
    private javax.swing.JTextArea RVText;
    private javax.swing.JMenuItem SaveAllOption20;
    private javax.swing.JMenuItem SaveFiltOption20;
    private javax.swing.JMenuItem SaveStatistics;
    private javax.swing.JLabel VLabel;
    private javax.swing.JPanel VPanel;
    private javax.swing.JTextArea VText;
    private javax.swing.JButton decIncButton;
    private javax.swing.JToggleButton drillingButton;
    private javax.swing.JMenu jMenu21;
    private javax.swing.JMenuBar jMenuBar21;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JPanel logoPanel;
    private javax.swing.JButton presentFieldButton;
    private javax.swing.JButton tcButton;
    private javax.swing.JButton tcButton1;
    // End of variables declaration//GEN-END:variables
    
}
